#!/usr/bin/env python

import re
import sys

pat_actions = re.compile(r"\s*[\[\]](.+)[\[\]]")

actions = set()

with open(sys.argv[1]) as f:
    for line in iter(f.readline, ''):
        m = pat_actions.match(line)
        if m:
            line_actions = set([act.strip() for act in m.group(1).split(",")])
            actions.update(line_actions)

print(len(actions))
