module Datact.Constants
  ( Constants
  , fromModel
  ) where


import Control.Lens

import           Data.Map.Strict (Map)
import qualified Data.Map.Strict as Map
import           Data.Maybe      (mapMaybe)

import Datact.Syntax


type Constants = Map Name Int


fromModel :: Model a -> Constants
fromModel (Model defs) =
    Map.fromList (mapMaybe fromConstant (toListOf (traverse._ConstDef) defs))


fromConstant :: Constant a -> Maybe (Name, Int)
fromConstant (Constant IntConstType name (Just (IntegerExpr i _)) _) =
    Just (name, fromIntegral i)
fromConstant _ = Nothing
