{-# LANGUAGE LambdaCase #-}

-- | The SrcLoc module defines the 'SrcLoc' type which is used to annotate
-- AST nodes with their location in the source file.
module Datact.SrcLoc
  ( SrcLoc(..)
  ) where


import Data.Text.Lazy (Text)

import Text.PrettyPrint.Leijen.Text


-- | The position in a source file.
data SrcLoc
  = SrcLoc !Text !Int !Int
  | NoLoc
  deriving (Show)

instance Pretty SrcLoc where
    pretty = \case
        SrcLoc file y x ->
            text file <> colon <> int y <> colon <> int x <> colon
        NoLoc -> empty

