package nl.cwi.reo.templates;

import java.util.List;
import java.util.Set;

import nl.cwi.reo.interpret.ports.Port;
import nl.cwi.reo.semantics.prba.RewardMonitor;
import nl.cwi.reo.semantics.prba.RewardMonitor.Rule;

/**
 * An atomic reward monitor.
 */
public class RewardsAtomic implements Component
{
	/**
	 * Flag for string template.
	 */
	public final boolean rewards = true;

	/**
	 * The name.
	 */
	private String name;

	/**
	 * The underlying reward monitor rules.
	 */
	private RewardMonitor rewardMonitor;

	/**
	 * Instantiates a new reward monitor component.
	 *
	 * @param name
	 *            the name
	 * @param rewardMonitor
	 *            the reward monitor
	 */
	public RewardsAtomic(String name, RewardMonitor rewardMonitor) {
		this.name = name;
		this.rewardMonitor = rewardMonitor; 
	}

	/**
	 * Get the name.
	 */
	public String getName() {
		return name;
	}

	@Override
	public Set<Port> getPorts()
	{
		return rewardMonitor.getInterface();
	}

	/**
	 * Get the rules.
	 */
	public List<Rule> getRules()
	{
		return rewardMonitor.getRules();
	}

}
